using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine;
using UnityEngine.SceneManagement;
using System.Linq;
using TMPro;
using UnityEngine.UI;

namespace Armor
{
    public class Mod
    {
        public static void Main()
        {
CategoryBuilder.Create("Special Air Service", "", ModAPI.LoadSprite("category icon.png"));       




 ModAPI.Register(
		    new Modification()
			{
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = "Colt Canada C8",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "3B",
                    CategoryOverride = ModAPI.FindCategory("Special Air Service"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/c8icon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();

		       var C8Slide = Instance.transform.Find("Slide");
                       C8Slide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/c8slide.png", 16f);
                       C8Slide.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);
                       C8Slide.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";

                        var HK = new GameObject("c8");
                        HK.transform.SetParent(Instance.transform);
                        HK.transform.localPosition = new Vector2(0f, 0f);
                        HK.transform.localScale = new Vector3(1f, 1f);
                        HK.transform.rotation = Instance.transform.rotation;
                        var HKSprite = HK.AddComponent<SpriteRenderer>();
                        HKSprite.sprite = ModAPI.LoadSprite("weapon/c8.png", 16f);
                        HKSprite.sortingLayerName = "Foreground";

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/c8.png", 16f);
                        Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);
                        Instance.FixColliders(); 
		        Instance.GetComponent<FirearmBehaviour>().casingPosition = new Vector2(0.30f,0.100f); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.86f, 0.12f);
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.16f;

                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/coltc8.mp3"),
                        };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "5.56×45";
                        customCartridge.Damage *= 5f;
                        customCartridge.Recoil *= 5f;
                        customCartridge.ImpactForce *= 5f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );


 ModAPI.Register(
		    new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Knife"),
                    NameOverride = "Small Combat Knife",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "3C",
                    CategoryOverride = ModAPI.FindCategory("Special Air Service"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/knifeicon.png"),
                    AfterSpawn = (Instance) =>
                    {
                       Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/knife.png", 20f);
                        Instance.FixColliders();
                        {
						}
 
                        {
                        };

		    }
                }
            );

 ModAPI.Register(
		    new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Pistol"),
                    NameOverride = "OZ9",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "3A",
                    CategoryOverride = ModAPI.FindCategory("Special Air Service"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/oz9icon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();
						
		       var GlockSlide = Instance.transform.Find("Slide");
                       GlockSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/oz9slide.png", 14f);

                       Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/oz9.png", 14f);
                        Instance.FixColliders(); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.14f, 0.05f);
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

                        var firearm = Instance.GetComponent<FirearmBehaviour>();
  
                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/glock.mp3"),
                        };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "Glock 17";
                        customCartridge.Damage = 4f;
                        customCartridge.Recoil = 1f;
                        customCartridge.ImpactForce = 0.5f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"), 
                    NameOverride = "Chest Rig", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2B",
                    CategoryOverride = ModAPI.FindCategory("Special Air Service"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/chesticon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/chest3.png", 12); 

                        int PartCount = 3;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/chest3.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("Armor/chest2.png", 12);
                        armProp[0].armorPiece = "MiddleBody";
                        armProp[0].offset = offset;
                        armProp[0].armorTier = 2;
                        armProp[0].scaleOffset = scaleOffset;
                        armProp[0].armorPoints = 350;

                        armProp[1].sprite = ModAPI.LoadSprite("Armor/chest1.png", 12);
                        armProp[1].armorPiece = "LowerBody";
                        armProp[1].offset = offset;
                        armProp[1].armorTier = 1;
                        armProp[1].scaleOffset = scaleOffset;
                        armProp[1].armorPoints = 250;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"), 
                    NameOverride = "Chest Rig + AVS", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2C",
                    CategoryOverride = ModAPI.FindCategory("Special Air Service"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/chestvesticon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/chestvest3.png", 12); 

                        int PartCount = 3;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/chestvest3.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("Armor/chestvest2.png", 12);
                        armProp[0].armorPiece = "MiddleBody";
                        armProp[0].offset = offset;
                        armProp[0].armorTier = 2;
                        armProp[0].scaleOffset = scaleOffset;
                        armProp[0].armorPoints = 350;

                        armProp[1].sprite = ModAPI.LoadSprite("Armor/chest1.png", 12);
                        armProp[1].armorPiece = "LowerBody";
                        armProp[1].offset = offset;
                        armProp[1].armorTier = 1;
                        armProp[1].scaleOffset = scaleOffset;
                        armProp[1].armorPoints = 250;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"), 
                    NameOverride = "AVS", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2A",
                    CategoryOverride = ModAPI.FindCategory("Special Air Service"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/jpcicon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/vest3.png", 12); 

                        int PartCount = 2;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/vest3.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("Armor/vest2.png", 12);
                        armProp[0].armorPiece = "MiddleBody";
                        armProp[0].offset = offset;
                        armProp[0].armorTier = 2;
                        armProp[0].scaleOffset = scaleOffset;
                        armProp[0].armorPoints = 350;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "22 SAS Trooper [Neck Gaiter]",
                    DescriptionOverride = " ", 
                    NameToOrderByOverride = "1B",
                    CategoryOverride = ModAPI.FindCategory("Special Air Service"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/sastropericon2.png"),
                    AfterSpawn = (Instance) => 
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var Head = Instance.transform.Find("Head").gameObject;

                        Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 12;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                        {
                            ModAPI.LoadTexture("Outfit/Variant 2.png"),
                        };
                    }
                }
            );          

 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "22 SAS Trooper",
                    DescriptionOverride = " ", 
                    NameToOrderByOverride = "1A",
                    CategoryOverride = ModAPI.FindCategory("Special Air Service"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/sastropericon.png"),
                    AfterSpawn = (Instance) => 
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var Head = Instance.transform.Find("Head").gameObject;

                        Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 12;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                        {
                            ModAPI.LoadTexture("Outfit/Variant 1.png"),
                        };
                    }
                }
            );          






        }












public class MultipleSpriteHumanBehaviour : MonoBehaviour
    {
        public Texture2D[] Textures = new Texture2D[0];
        public PersonBehaviour person;
        public int CurrentTexture = -2;
        public int Scale = 3;

        void Start()
        {
            SetTexture();
        }

        public void SetTexture()
        {
            if (Textures.Length == 0)
                return;

            if(CurrentTexture == -2)
            {
                CurrentTexture = UnityEngine.Random.Range(0, Textures.Length);
            }
            person.SetBodyTextures(Textures[CurrentTexture], null, null, Scale);
            for (int i = 0; i < person.Limbs.Length; i++)
            {
                person.Limbs[i].gameObject.GetComponent<PhysicalBehaviour>().RefreshOutline();
            }
        }
}    }
}
